Ruby 2.0.0p353(2013-11-22revision43784)

- Main Page
- Modules
- Data Structures
- Files

- File List
- Globals

Data Structures | Macros | Functions | Variables
pty.c File Reference
`#include "ruby/config.h"`
`#include <stdlib.h>`
`#include <stdio.h>`
`#include <sys/types.h>`
`#include <sys/stat.h>`
`#include <sys/file.h>`
`#include <fcntl.h>`
`#include <errno.h>`
`#include <pwd.h>`
`#include <ctype.h>`
`#include "ruby/ruby.h"`
`#include "ruby/io.h"`
`#include "ruby/util.h"`
`#include "internal.h"`
`#include <signal.h>`
Include dependency graph for pty.c:

Go to the source code of this file.

## Data Structures
struct | pty_info
struct | child_info

## Macros
#define | WIFSTOPPED(status) (((status) & 0xff) == 0x7f)
#define | DEVICELEN 16
#define | ERROR_EXIT(str)

## Functions
static VALUE | echild_status (VALUE self)
static void | getDevice (int *, int *, char[DEVICELEN], int)
static int | chfunc (void *data, char *errbuf, size_t errbuf_len)
static void | establishShell (int argc, VALUE *argv, struct pty_info *info, char SlaveName[DEVICELEN])
static int | no_mesg (char *slavedevice, int nomesg)
static int | get_device_once (int *master, int *slave, char SlaveName[DEVICELEN], int nomesg, int fail)
static VALUE | pty_close_pty (VALUE assoc)
static VALUE | pty_open (VALUE klass)
static VALUE | pty_detach_process (struct pty_info *info)
static VALUE | pty_getpty (int argc, VALUE *argv, VALUE self)
| NORETURN (static void raise_from_check(pid_t pid, int status))
static void | raise_from_check (pid_t pid, int status)
static VALUE | pty_check (int argc, VALUE *argv, VALUE self)
void | Init_pty ()

## Variables
static VALUE | eChildExited
static VALUE | cPTY

## Macro Definition Documentation

#define DEVICELEN 16

Definition at line 46 of file pty.c.

Referenced by get_device_once(), pty_getpty(), and pty_open().

#define ERROR_EXIT | ( |  | str | ) |

Value:
do { \
strlcpy(errbuf, (str), errbuf_len); \
return -1; \
} while (0)
return
return
Definition: bigdecimal.c:5800
strlcpy
RUBY_EXTERN size_t strlcpy(char *, const char *, size_t)
str
static VALUE char * str
Definition: tcltklib.c:3547

Referenced by chfunc().

#define WIFSTOPPED | ( |  | status | ) | (((status) & 0xff) == 0x7f)

Definition at line 28 of file pty.c.

Referenced by raise_from_check().

## Function Documentation

static int chfunc | ( | void * | data,
|  | char * | errbuf,
|  | size_t | errbuf_len
| ) |  |
| static

Definition at line 86 of file pty.c.

References data, dup2(), child_info::eargp, ERROR_EXIT, getuid(), i, ioctl(), child_info::master, master, rb_cloexec_open(), rb_exec_async_signal_safe(), rb_update_max_fd(), seteuid(), child_info::slave, slave, child_info::slavename, and void.

Referenced by establishShell(), and rb_f_system().

static VALUE echild_status | ( | VALUE | self | ) |
| static

Definition at line 66 of file pty.c.

References rb_intern, and rb_ivar_get().

Referenced by Init_pty().

static void establishShell | ( | int | argc,
|  | VALUE * | argv,
|  | struct pty_info * | info,
|  | char | SlaveName[DEVICELEN]
| ) |  |
| static

Definition at line 151 of file pty.c.

References chfunc(), pty_info::child_pid, e, child_info::eargp, errno, child_info::execarg_obj, pty_info::fd, getDevice(), getenv(), getuid(), child_info::master, master, NULL, p, Qnil, rb_execarg_fixup(), rb_execarg_get(), rb_execarg_new(), rb_fork_async_signal_safe(), RB_GC_GUARD, rb_jump_tag(), rb_str_new2, rb_sys_fail(), child_info::slave, slave, child_info::slavename, status, and v.

Referenced by pty_getpty().

static int get_device_once | ( | int * | master,
|  | int * | slave,
|  | char | SlaveName[DEVICELEN],
|  | int | nomesg,
|  | int | fail
| ) |  |
| static

Definition at line 219 of file pty.c.

References chown(), DEVICELEN, flags, getgid(), getuid(), ioctl(), mode, mode_t, name, no_mesg(), NULL, O_CLOEXEC, p, rb_cloexec_open(), rb_eRuntimeError, rb_fd_fix_cloexec(), rb_raise(), rb_update_max_fd(), s, signal(), snprintf, strlcpy(), and void.

Referenced by getDevice().

static void getDevice | ( | int * | master,
|  | int * | slave,
|  | char | SlaveName[DEVICELEN],
|  | int | nomesg
| ) |  |
| static

Definition at line 450 of file pty.c.

References get_device_once(), and rb_gc().

Referenced by establishShell(), and pty_open().

void Init_pty | ( |  | ) |

Definition at line 739 of file pty.c.

References echild_status(), eChildExited, pty_check(), pty_getpty(), pty_open(), rb_define_class_under(), rb_define_method(), rb_define_module(), rb_define_module_function(), rb_define_singleton_method(), and rb_eRuntimeError.

static int no_mesg | ( | char * | slavedevice,
|  | int | nomesg
| ) |  |
| static

Definition at line 210 of file pty.c.

Referenced by get_device_once().

NORETURN | ( | static void | raise_from_checkpid_t pid, int status | ) |

static VALUE pty_check | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |
| static

Definition at line 654 of file pty.c.

References exc, NUM2PIDT, Qnil, raise_from_check(), rb_last_status_get(), rb_scan_args(), rb_waitpid(), RTEST, status, UNREACHABLE, and WNOHANG.

Referenced by Init_pty().

static VALUE pty_close_pty | ( | VALUE | assoc | ) |
| static

Definition at line 459 of file pty.c.

References i, io, Qnil, rb_ary_entry(), rb_io_close(), RB_TYPE_P, RFILE, and T_FILE.

Referenced by pty_open().

static VALUE pty_detach_process | ( | struct pty_info * | info | ) |
| static

Definition at line 535 of file pty.c.

References pty_info::child_pid, Qnil, and rb_detach_process().

Referenced by pty_getpty().

static VALUE pty_getpty | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |
| static

Definition at line 570 of file pty.c.

References pty_info::child_pid, DEVICELEN, establishShell(), pty_info::fd, FMODE_SYNC, MakeOpenFile, PIDT2NUM, pty_detach_process(), Qnil, rb_ary_new2(), rb_ary_store(), rb_block_given_p(), rb_cFile, rb_cloexec_dup(), rb_ensure(), rb_io_mode_flags, rb_obj_alloc(), rb_obj_freeze(), rb_str_new_cstr(), rb_sys_fail(), rb_update_max_fd(), rb_yield(), and res.

Referenced by Init_pty().

static VALUE pty_open | ( | VALUE | klass | ) |
| static

Definition at line 505 of file pty.c.

References assoc, DEVICELEN, rb_io_t::fd, FMODE_DUPLEX, FMODE_READWRITE, FMODE_SYNC, FMODE_TTY, getDevice(), MakeOpenFile, rb_io_t::mode, rb_io_t::pathv, pty_close_pty(), rb_assoc_new(), rb_block_given_p(), rb_cFile, rb_cIO, rb_ensure(), rb_obj_alloc(), rb_obj_freeze(), rb_sprintf(), rb_str_new_cstr(), and rb_yield().

Referenced by Init_pty().

static void raise_from_check | ( | pid_t | pid,
|  | int | status
| ) |  |
| static

Definition at line 609 of file pty.c.

References buf, eChildExited, exc, kill(), rb_exc_new2(), rb_exc_raise(), rb_iv_set(), rb_last_status_get(), snprintf, state, and WIFSTOPPED.

Referenced by pty_check().

## Variable Documentation

VALUE cPTY
| static

Definition at line 670 of file pty.c.

VALUE eChildExited
| static

Definition at line 60 of file pty.c.

Referenced by Init_pty(), and raise_from_check().